package com.edgec.browserbackend.browser.ErrorCode;

import com.edgec.browserbackend.browser.domain.IpTransaction;
import com.edgec.browserbackend.common.commons.error.ErrorCode;
import com.fasterxml.jackson.annotation.JsonValue;

public enum BrowserErrorCode implements ErrorCode {

    /* client errors */

    UNKNOWN(ErrorCode.COMMON_UNKNOWN,"unknown"),
    INFORMATIONNOTCOMPELETE(BROWSER_BASE+100, "The information about shop do not complete"),
    SHOPNOTEXIST(BROWSER_BASE+101, "The shop do not exist"),

    IPNOTEXIST(BROWSER_BASE+201, "The ip do not exist"),
    IPNOTBINDTOSHOP(BROWSER_BASE+202, "The ip do not bind this shop."),

    GROUPNOTEXIST(BROWSER_BASE+301, "The group do not exist"),

    IPTRANSACTIONNOTEXIST(BROWSER_BASE+401, "The ipTransaction do not exist");



    private final int code;
    private final String reason;

    private BrowserErrorCode(int value, String reasonPhrase) {
        this.code = value;
        this.reason = reasonPhrase;
    }

    public int value() {
        return this.code;
    }

    @JsonValue
    public int getCode() {
        return code;
    }

    @Override
    public String toString() {
        return Integer.toString(this.code);
    }

    public String getReason() {
        return reason;
    }
}
