package com.edgec.browserbackend.browser.repository;

import com.edgec.browserbackend.browser.domain.LoginHistory;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.mongodb.repository.MongoRepository;

public interface LoginHistoryRepository extends MongoRepository<LoginHistory, String> {
    LoginHistory findFirstByAccount(String account);

    Page<LoginHistory> findByAdministratorOrderByLoginTime(String administrator, Pageable pageable);

    Page<LoginHistory> findByAccountOrderByLoginTime(String account, Pageable pageable);

    int countByAccount(String account);
}
